-- Main startup file

-- Initialize the custom package loading
package.loaders = { loadownmodule }

-- Screen settings (set by the game engine)
--screen_width = 1024
--screen_height = 768

require("Mesh_Builder")
require("Screen_Load")
require("Screen_Test_Mesh")

-- Global camera
global_camera = camera_create()
camera_set_perspective(global_camera, 90, screen_width / screen_height, 0.1, 1000.0)

-- Create the startup screen
--current_screen = new_screen_test("cube_smooth")
current_screen = new_screen_load()

print("Done initializing..")

-- Called every frame update
function global_update(delta_t)
	if current_screen == nil then
		return false
	end
	
	current_screen = current_screen:update(delta_t)
	return (current_screen ~= nil)
end

-- Called on render
function global_render()
	current_screen:render()
	end
