require("Resources")
require("Renderer_Text")

function new_renderer()
	return
		{
			meshes = {},
			texts = {},

			cam_mtx = mat4_idn(),

			renderer_text = new_renderer_text(),
		
			new_frame = function(this)
				this.meshes = {}
				this.texts = {}
				this.cam_mtx = mat4_idn()
				end,
				
			set_camera = function(this, cam_mtx)
				this.cam_mtx = cam_mtx
				end,
				
			add_mesh = function(this, mesh_name, mtx, mat)
				local mesh = resources:get(mesh_name)
				if mesh == nil then return end
				
				table.insert(this.meshes, { mesh, mtx, mat })
				end,
				
			add_text = function(this, txt, pos_x, pos_y, scale)
				scale = scale or 1
				table.insert(this.texts, { txt, pos_x, pos_y, scale })
				end,
				
			render = function(this)
				render_bind_target()
				render_clear()
				render_set_camera(global_camera, this.cam_mtx)
--				render_set_shader(resources:get("shader_normal"))

				for k,v in pairs(this.meshes) do
					local mesh, obj_mtx, mat = v[1], v[2], v[3]
					
					-- Set the shader args
					for uniform_name, uniform_value in pairs(mat.shader_values) do
						shader_set(mat.shader, uniform_name, uniform_value)
					end
					
					-- Render the mesh
					render_mesh(mesh, obj_mtx, mat.appearance)
				end

				--[[local c1 = 0
				local c2 = 100
				render_line(vec3(c1,0,0), vec3(c2,0,0), 0xff0000ff)
				render_line(vec3(0,c1,0), vec3(0,c2,0), 0x00ff00ff)
				render_line(vec3(0,0,c1), vec3(0,0,c2), 0x0000ffff)]]
				
				-- Render the text
				this.renderer_text:start()
				for k,v in pairs(this.texts) do
					this.renderer_text:print(v[1], v[2], v[3], v[4])
				end
				
				render_release_target()
				end,
		}
end
