require("Game_Area")
require("Renderer")

function new_screen_game()
	-- Start the music
	audio_play_stream("Data/Audio/music_ingame.ogg")

	return
		{
			renderer = new_renderer(),

			game_area = new_game_area(),
			
			death_timer = 0,
			visible_score = 0,
			
			update = function(this, delta_t)
				-- Game area update
				this.game_area:update(delta_t)
				
				-- Death countdown
				if not this.game_area.player.is_alive then
					this.death_timer = this.death_timer + delta_t
					if this.death_timer > 4 then
						return new_screen_menu()
					end
				end
				
				-- Scroll the score
				this.visible_score = lerp(this.visible_score, this.game_area.score, 0.1)
				
				return this
				end,
				
			render = function(this)
				local cam_pos = vec3(0, 20, -5)
				local cam_mtx = mat4_target_at(cam_pos, vec3(0,0,0), vec3_unit(vec3(0,1,1)))

				this.renderer:new_frame()
				this.renderer:set_camera(cam_mtx)
				
				this.game_area:render(this.renderer)
				
				this.renderer:add_text("Score:" .. math.ceil(this.visible_score), -140, 140)
--				this.renderer:add_text("Lives:" .. this.game_area.lives, -140, 130)
--				this.renderer:add_text("Difficulty:" .. math.floor(this.game_area.difficulty * 100), -140, 120)

				if not this.game_area.player.is_alive then
					this.renderer:add_text("GAME OVER", -105, 20, 3)
				end
				
				this.renderer:render()
				end,
		}
end
