shaders =
{
	vs_normal = [[
uniform vec4 color;

void main()
{
//	M3Gposition = m3g_modelViewProjectionMatrix * vec4(m3g_position, 1.0);
//	gl_Position = M3Gposition;
	gl_Position = m3g_modelViewProjectionMatrix * vec4(m3g_position, 1.0);
//	gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;
//	out_color = vec4(m3g_normal.x,m3g_normal.y,m3g_normal.z,1);

//	vec3 normal = normalize((vec4(m3g_normal,1.0) * m3g_normalMatrix).xyz);
	vec3 normal = normalize((m3g_normalMatrix * vec4(m3g_normal,1.0)).xyz);
	float lv = abs(normal.y);
	m3g_out_vColor = vec4(lv,lv,lv,1) * color;
}
	]],

	vs_bullet = [[
uniform vec4 color;

void main()
{
	gl_Position = m3g_modelViewProjectionMatrix * vec4(m3g_position, 1.0);
	vec3 normal = normalize((vec4(m3g_normal,1.0) * m3g_normalMatrix).xyz);
//	vec3 normal = normalize((m3g_normalMatrix * vec4(m3g_normal,1.0)).xyz);
	float lv = mix(0.5, 1, abs(normal.z));
	m3g_out_vColor = vec4(lv,lv,lv,pow(abs(normal.z), 3)) * color;
//	m3g_out_vColor = color;
}
	]],

	vs_enemy = [[
uniform vec4 color;
uniform float flashing;

void main()
{
	gl_Position = m3g_modelViewProjectionMatrix * vec4(m3g_position, 1.0);
	vec3 normal = normalize((m3g_normalMatrix * vec4(m3g_normal,1.0)).xyz);
	float lv = abs(normal.y);
	vec4 col = vec4(lv,lv,lv,1) * color;
	m3g_out_vColor = mix(col, vec4(1, 1, 1, 1), flashing);
}
	]],
	
	vs_normal_line = [[
void main()
{
	gl_Position = m3g_modelViewProjectionMatrix * vec4(m3g_position, 1.0);
	m3g_out_vColor = m3g_color / 255.0;
}
	]],
	
	fs_normal = [[
//varying lowp vec4 pos;
//varying highp vec2 texcoord0;

void main()
{
	gl_FragColor = m3g_out_vColor;
}
	]],
}
